<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CollateralLinkRespType StructType
 * @subpackage Structs
 */
class CollateralLinkRespType extends AbstractStructBase
{
    /**
     * The DebtObligationAccNumber
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $DebtObligationAccNumber;
    /**
     * The CollateralCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CollateralCode;
    /**
     * The BaseCalculationKey
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $BaseCalculationKey;
    /**
     * The BaseCalculationValue
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var float
     */
    public $BaseCalculationValue;
    /**
     * The Status
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Status;
    /**
     * The StatusMessage
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $StatusMessage;
    /**
     * Constructor method for CollateralLinkRespType
     * @uses CollateralLinkRespType::setDebtObligationAccNumber()
     * @uses CollateralLinkRespType::setCollateralCode()
     * @uses CollateralLinkRespType::setBaseCalculationKey()
     * @uses CollateralLinkRespType::setBaseCalculationValue()
     * @uses CollateralLinkRespType::setStatus()
     * @uses CollateralLinkRespType::setStatusMessage()
     * @param string $debtObligationAccNumber
     * @param string $collateralCode
     * @param string $baseCalculationKey
     * @param float $baseCalculationValue
     * @param string $status
     * @param string $statusMessage
     */
    public function __construct($debtObligationAccNumber = null, $collateralCode = null, $baseCalculationKey = null, $baseCalculationValue = null, $status = null, $statusMessage = null)
    {
        $this
            ->setDebtObligationAccNumber($debtObligationAccNumber)
            ->setCollateralCode($collateralCode)
            ->setBaseCalculationKey($baseCalculationKey)
            ->setBaseCalculationValue($baseCalculationValue)
            ->setStatus($status)
            ->setStatusMessage($statusMessage);
    }
    /**
     * Get DebtObligationAccNumber value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDebtObligationAccNumber()
    {
        return isset($this->DebtObligationAccNumber) ? $this->DebtObligationAccNumber : null;
    }
    /**
     * Set DebtObligationAccNumber value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $debtObligationAccNumber
     * @return \StructType\CollateralLinkRespType
     */
    public function setDebtObligationAccNumber($debtObligationAccNumber = null)
    {
        // validation for constraint: string
        if (!is_null($debtObligationAccNumber) && !is_string($debtObligationAccNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($debtObligationAccNumber, true), gettype($debtObligationAccNumber)), __LINE__);
        }
        if (is_null($debtObligationAccNumber) || (is_array($debtObligationAccNumber) && empty($debtObligationAccNumber))) {
            unset($this->DebtObligationAccNumber);
        } else {
            $this->DebtObligationAccNumber = $debtObligationAccNumber;
        }
        return $this;
    }
    /**
     * Get CollateralCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCollateralCode()
    {
        return isset($this->CollateralCode) ? $this->CollateralCode : null;
    }
    /**
     * Set CollateralCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $collateralCode
     * @return \StructType\CollateralLinkRespType
     */
    public function setCollateralCode($collateralCode = null)
    {
        // validation for constraint: string
        if (!is_null($collateralCode) && !is_string($collateralCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($collateralCode, true), gettype($collateralCode)), __LINE__);
        }
        if (is_null($collateralCode) || (is_array($collateralCode) && empty($collateralCode))) {
            unset($this->CollateralCode);
        } else {
            $this->CollateralCode = $collateralCode;
        }
        return $this;
    }
    /**
     * Get BaseCalculationKey value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getBaseCalculationKey()
    {
        return isset($this->BaseCalculationKey) ? $this->BaseCalculationKey : null;
    }
    /**
     * Set BaseCalculationKey value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $baseCalculationKey
     * @return \StructType\CollateralLinkRespType
     */
    public function setBaseCalculationKey($baseCalculationKey = null)
    {
        // validation for constraint: string
        if (!is_null($baseCalculationKey) && !is_string($baseCalculationKey)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($baseCalculationKey, true), gettype($baseCalculationKey)), __LINE__);
        }
        if (is_null($baseCalculationKey) || (is_array($baseCalculationKey) && empty($baseCalculationKey))) {
            unset($this->BaseCalculationKey);
        } else {
            $this->BaseCalculationKey = $baseCalculationKey;
        }
        return $this;
    }
    /**
     * Get BaseCalculationValue value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return float|null
     */
    public function getBaseCalculationValue()
    {
        return isset($this->BaseCalculationValue) ? $this->BaseCalculationValue : null;
    }
    /**
     * Set BaseCalculationValue value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param float $baseCalculationValue
     * @return \StructType\CollateralLinkRespType
     */
    public function setBaseCalculationValue($baseCalculationValue = null)
    {
        // validation for constraint: float
        if (!is_null($baseCalculationValue) && !(is_float($baseCalculationValue) || is_numeric($baseCalculationValue))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($baseCalculationValue, true), gettype($baseCalculationValue)), __LINE__);
        }
        if (is_null($baseCalculationValue) || (is_array($baseCalculationValue) && empty($baseCalculationValue))) {
            unset($this->BaseCalculationValue);
        } else {
            $this->BaseCalculationValue = $baseCalculationValue;
        }
        return $this;
    }
    /**
     * Get Status value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getStatus()
    {
        return isset($this->Status) ? $this->Status : null;
    }
    /**
     * Set Status value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $status
     * @return \StructType\CollateralLinkRespType
     */
    public function setStatus($status = null)
    {
        // validation for constraint: string
        if (!is_null($status) && !is_string($status)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($status, true), gettype($status)), __LINE__);
        }
        if (is_null($status) || (is_array($status) && empty($status))) {
            unset($this->Status);
        } else {
            $this->Status = $status;
        }
        return $this;
    }
    /**
     * Get StatusMessage value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getStatusMessage()
    {
        return isset($this->StatusMessage) ? $this->StatusMessage : null;
    }
    /**
     * Set StatusMessage value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $statusMessage
     * @return \StructType\CollateralLinkRespType
     */
    public function setStatusMessage($statusMessage = null)
    {
        // validation for constraint: string
        if (!is_null($statusMessage) && !is_string($statusMessage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($statusMessage, true), gettype($statusMessage)), __LINE__);
        }
        if (is_null($statusMessage) || (is_array($statusMessage) && empty($statusMessage))) {
            unset($this->StatusMessage);
        } else {
            $this->StatusMessage = $statusMessage;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CollateralLinkRespType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
